/*** Copyright: OGIHARA Takeshi, March 2006 ***/

#import <Foundation/Foundation.h>

@interface A : NSObject <NSCopying>
@end

@implementation A
- (id)copyWithZone:(NSZone *)zone
{
    return [[[self class] allocWithZone:zone] init];
}
@end

@interface B : A
@end

@implementation B
@end

int main(void)
{
    id pool = [[NSAutoreleasePool alloc] init];
    id obj = [[NSObject alloc] init];
    id a = [[A alloc] init];
    id b = [[B alloc] init];
    printf("%s\n",
        [obj conformsToProtocol:@protocol(NSCopying)] ? "YES" : "NO");
    printf("%s\n",
        [a conformsToProtocol:@protocol(NSCopying)] ? "YES" : "NO");
    printf("%s\n",
        [b conformsToProtocol:@protocol(NSCopying)] ? "YES" : "NO");
    b = [obj copy];
    [pool release];
    return 0;
}
