/*** Copyright: OGIHARA Takeshi, April 2008 ***/

#import "Philosopher.h"
#import <Foundation/Foundation.h>
#import <stdlib.h>
#import <unistd.h> // for getpid()

@implementation Philosopher

static id sharedLock = nil;

+ (void)initialize
{
    if (sharedLock == nil) {
        sharedLock = [[NSObject alloc] init];
        srandom(getpid());
    }
}

- (id)initWithLeft:(id)llock right:(id)rlock;
{
    if ((self = [super init]) != nil) {
        leftLock = llock;
        rightLock = rlock;
        tag = 0;
        state = phil_Meditation;
    }
    return self;
}

@synthesize tag;

static void waitAMoment(int r) {
    int n = r * r;
    while (n-- > 0) ;
}

- (void)start:(id)sender
{
    int rnd = tag * 50;

    while ( 1 ) {
        @synchronized(leftLock) {
            state = phil_WaitRight;
            waitAMoment(rnd);
            @synchronized(rightLock) {

                state = phil_Eating;
                @synchronized(sharedLock) {
                    // random() and printf() are thread-unsafe.
                    rnd = random() % 1000 + 1;
                    printf("Philosopher #%d\n", tag);
                }
            }
        }
        state = phil_Meditation;
        waitAMoment(rnd);
    }
}

@end
