/*** Copyright: OGIHARA Takeshi, April 2008 ***/

#import <Foundation/Foundation.h>
#import "Philosopher.h"

#define PHILOSOPHERS  5

int main(void)
{
    NSLock *forks[PHILOSOPHERS];
    Philosopher *phils[PHILOSOPHERS];
    int i, j;
    id pool = [[NSAutoreleasePool alloc] init];

    for (i = 0; i < PHILOSOPHERS; i++)
        forks[i] = [[NSObject alloc] init];
    for (i = 0, j = PHILOSOPHERS-1; i < PHILOSOPHERS; j = i++) {
        phils[i] = [[Philosopher alloc]
                initWithLeft:forks[j] right:forks[i]];
        phils[i].tag = i;
    }
    for (i = 0; i < PHILOSOPHERS; i++)
        [NSThread detachNewThreadSelector:@selector(start:)
            toTarget:phils[i] withObject:nil];
    (void)getchar(); // wait here
    [pool release];
    return 0;
}
